Generated Dart libraries for accessing
[Google APIs](https://developers.google.com/api-client-library).

To use these APIs from Flutter, see the
[Flutter Google APIs documentation](https://flutter.dev/docs/development/data-and-backend/google-apis).

For example of using these APIs from a Dart console example see the example in
this package. For an example of usage in a server application,
[see this example](https://github.com/dart-lang/samples/tree/master/server/google_apis).

## Available Google APIs

The following is a list of APIs that are currently available inside this
package.

#### Ad Exchange Buyer API II - `adexchangebuyer2.v2beta1`

Accesses the latest features for managing Authorized Buyers accounts, Real-Time Bidding configurations and auction metrics, and Marketplace programmatic deals.

- [Documentation](https://developers.google.com/authorized-buyers/apis/reference/rest/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/adexchangebuyer2.v2beta1/adexchangebuyer2.v2beta1-library.html)

#### Google Workspace Alert Center API - `alertcenter.v1beta1`

Manages alerts on issues affecting your domain.

- [Documentation](https://developers.google.com/admin-sdk/alertcenter/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/alertcenter.v1beta1/alertcenter.v1beta1-library.html)

#### Google Analytics Admin API - `analyticsadmin.v1alpha`

- [Documentation](http://code.google.com/apis/analytics/docs/mgmt/home.html)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/analyticsadmin.v1alpha/analyticsadmin.v1alpha-library.html)

#### Google Analytics Data API - `analyticsdata.v1beta`

Accesses report data in Google Analytics.

- [Documentation](https://developers.google.com/analytics/devguides/reporting/data/v1/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/analyticsdata.v1beta/analyticsdata.v1beta-library.html)

#### Area120 Tables API - `area120tables.v1alpha1`

- [Documentation](https://support.google.com/area120-tables/answer/10011390)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/area120tables.v1alpha1/area120tables.v1alpha1-library.html)

#### BigQuery Connection API - `bigqueryconnection.v1beta1`

Allows users to manage BigQuery connections to external data sources.

- [Documentation](https://cloud.google.com/bigquery/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/bigqueryconnection.v1beta1/bigqueryconnection.v1beta1-library.html)

#### Error Reporting API - `clouderrorreporting.v1beta1`

Groups and counts similar errors from cloud services and applications, reports new errors, and provides access to error groups and their associated errors. 

- [Documentation](https://cloud.google.com/error-reporting/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/clouderrorreporting.v1beta1/clouderrorreporting.v1beta1-library.html)

#### Container Analysis API - `containeranalysis.v1beta1`

An implementation of the Grafeas API, which stores, and enables querying and retrieval of critical metadata about all of your software artifacts.

- [Documentation](https://cloud.google.com/container-analysis/api/reference/rest/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/containeranalysis.v1beta1/containeranalysis.v1beta1-library.html)

#### Google Cloud Data Catalog API - `datacatalog.v1beta1`

A fully managed and highly scalable data discovery and metadata management service. 

- [Documentation](https://cloud.google.com/data-catalog/docs/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/datacatalog.v1beta1/datacatalog.v1beta1-library.html)

#### Dataflow API - `dataflow.v1b3`

Manages Google Cloud Dataflow projects on Google Cloud Platform.

- [Documentation](https://cloud.google.com/dataflow)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/dataflow.v1b3/dataflow.v1b3-library.html)

#### Data Labeling API - `datalabeling.v1beta1`

Public API for Google Cloud AI Data Labeling Service.

- [Documentation](https://cloud.google.com/data-labeling/docs/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/datalabeling.v1beta1/datalabeling.v1beta1-library.html)

#### Datastream API - `datastream.v1alpha1`

- [Documentation](https://cloud.google.com/datastream/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/datastream.v1alpha1/datastream.v1alpha1-library.html)

#### Cloud Document AI API - `documentai.v1beta3`

Service to parse structured information from unstructured or semi-structured documents using state-of-the-art Google AI such as natural language, computer vision, translation, and AutoML.

- [Documentation](https://cloud.google.com/document-ai/docs/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/documentai.v1beta3/documentai.v1beta3-library.html)

#### Cloud Domains API - `domains.v1beta1`

Enables management and configuration of domain names.

- [Documentation](https://cloud.google.com/domains/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/domains.v1beta1/domains.v1beta1-library.html)

#### Fact Check Tools API - `factchecktools.v1alpha1`

- [Documentation](https://developers.google.com/fact-check/tools/api/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/factchecktools.v1alpha1/factchecktools.v1alpha1-library.html)

#### Firebase Cloud Messaging Data API - `fcmdata.v1beta1`

Provides additional information about Firebase Cloud Messaging (FCM) message sends and deliveries.

- [Documentation](https://firebase.google.com/docs/cloud-messaging)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/fcmdata.v1beta1/fcmdata.v1beta1-library.html)

#### Firebase Management API - `firebase.v1beta1`

The Firebase Management API enables programmatic setup and management of Firebase projects, including a project's Firebase resources and Firebase apps.

- [Documentation](https://firebase.google.com)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/firebase.v1beta1/firebase.v1beta1-library.html)

#### Firebase App Check API - `firebaseappcheck.v1beta`

Firebase App Check works alongside other Firebase services to help protect your backend resources from abuse, such as billing fraud or phishing.

- [Documentation](https://firebase.google.com/docs/app-check)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/firebaseappcheck.v1beta/firebaseappcheck.v1beta-library.html)

#### Firebase Realtime Database Management API - `firebasedatabase.v1beta`

The Firebase Realtime Database Management API enables programmatic provisioning and management of Realtime Database instances.

- [Documentation](https://firebase.google.com/docs/reference/rest/database/database-management/rest/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/firebasedatabase.v1beta/firebasedatabase.v1beta-library.html)

#### Cloud Storage for Firebase API - `firebasestorage.v1beta`

The Cloud Storage for Firebase API enables programmatic management of Cloud Storage buckets for use in Firebase projects

- [Documentation](https://firebase.google.com/docs/storage)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/firebasestorage.v1beta/firebasestorage.v1beta-library.html)

#### Idea Hub API - `ideahub.v1beta`

This is an invitation-only API.

- [Documentation](https://console.cloud.google.com/apis/library/ideahub.googleapis.com)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/ideahub.v1beta/ideahub.v1beta-library.html)

#### Cloud Life Sciences API - `lifesciences.v2beta`

Cloud Life Sciences is a suite of services and tools for managing, processing, and transforming life sciences data.

- [Documentation](https://cloud.google.com/life-sciences)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/lifesciences.v2beta/lifesciences.v2beta-library.html)

#### Dataproc Metastore API - `metastore.v1beta`

The Dataproc Metastore API is used to manage the lifecycle and configuration of metastore services.

- [Documentation](https://cloud.google.com/dataproc-metastore/docs)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/metastore.v1beta/metastore.v1beta-library.html)

#### Network Connectivity API - `networkconnectivity.v1alpha1`

The Network Connectivity API provides access to Network Connectivity Center.

- [Documentation](https://cloud.google.com/network-connectivity/docs/reference/networkconnectivity/rest)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/networkconnectivity.v1alpha1/networkconnectivity.v1alpha1-library.html)

#### Network Security API - `networksecurity.v1beta1`

- [Documentation](https://cloud.google.com/networking)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/networksecurity.v1beta1/networksecurity.v1beta1-library.html)

#### On-Demand Scanning API - `ondemandscanning.v1beta1`

A service to scan container images for vulnerabilities.

- [Documentation](https://cloud.google.com/container-analysis/docs/on-demand-scanning/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/ondemandscanning.v1beta1/ondemandscanning.v1beta1-library.html)

#### OS Config API - `osconfig.v1alpha`

OS management tools that can be used for patch management, patch compliance, and configuration management on VM instances.

- [Documentation](https://cloud.google.com/compute/docs/osconfig/rest)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/osconfig.v1alpha/osconfig.v1alpha-library.html)

#### Policy Simulator API - `policysimulator.v1beta1`

 Policy Simulator is a collection of endpoints for creating, running, and viewing a Replay. A `Replay` is a type of simulation that lets you see how your members' access to resources might change if you changed your IAM policy. During a `Replay`, Policy Simulator re-evaluates, or replays, past access attempts under both the current policy and your proposed policy, and compares those results to determine how your members' access might change under the proposed policy.

- [Documentation](https://cloud.google.com/iam/docs/simulating-access)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/policysimulator.v1beta1/policysimulator.v1beta1-library.html)

#### Certificate Authority API - `privateca.v1beta1`

The Certificate Authority Service API is a highly-available, scalable service that enables you to simplify and automate the management of private certificate authorities (CAs) while staying in control of your private keys." 

- [Documentation](https://cloud.google.com/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/privateca.v1beta1/privateca.v1beta1-library.html)

#### SAS Portal API (Testing) - `prod_tt_sasportal.v1alpha1`

- [Documentation](https://developers.google.com/spectrum-access-system/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/prod_tt_sasportal.v1alpha1/prod_tt_sasportal.v1alpha1-library.html)

#### Recommendations AI (Beta) - `recommendationengine.v1beta1`

Note that we now highly recommend new customers to use Retail API, which incorporates the GA version of the Recommendations AI funtionalities. To enable Retail API, please visit https://console.cloud.google.com/apis/library/retail.googleapis.com. The Recommendations AI service enables customers to build end-to-end personalized recommendation systems without requiring a high level of expertise in machine learning, recommendation system, or Google Cloud.

- [Documentation](https://cloud.google.com/recommendations-ai/docs)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/recommendationengine.v1beta1/recommendationengine.v1beta1-library.html)

#### SAS Portal API - `sasportal.v1alpha1`

- [Documentation](https://developers.google.com/spectrum-access-system/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/sasportal.v1alpha1/sasportal.v1alpha1-library.html)

#### Cloud SQL Admin API - `sqladmin.v1beta4`

API for Cloud SQL database instance management

- [Documentation](https://developers.google.com/cloud-sql/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/sqladmin.v1beta4/sqladmin.v1beta4-library.html)

#### Cloud Tool Results API - `toolresults.v1beta3`

API to publish and access results from developer tools.

- [Documentation](https://firebase.google.com/docs/test-lab/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/toolresults.v1beta3/toolresults.v1beta3-library.html)

#### Cloud TPU API - `tpu.v2alpha1`

TPU API provides customers with access to Google TPU technology.

- [Documentation](https://cloud.google.com/tpu/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/tpu.v2alpha1/tpu.v2alpha1-library.html)

#### Transcoder API - `transcoder.v1beta1`

This API converts video files into formats suitable for consumer distribution. 

- [Documentation](https://cloud.google.com/transcoder/docs/)
- [API details](https://pub.dev/documentation/googleapis_beta/7.0.0/transcoder.v1beta1/transcoder.v1beta1-library.html)

